#ifndef __PMACROS_HEADER_INCLUDED__
#define __PMACROS_HEADER_INCLUDED__

#if __BYTE_ORDER == __LITTLE_ENDIAN

/* byte swapping macros for little endian systems */
#define __swap_16(x) \
	((u_int16_t)( \
		(((u_int16_t)(x) & (u_int16_t)0x00ffU) << 8) | \
	 	(((u_int16_t)(x) & (u_int16_t)0xff00U) >> 8) ))
#define __swap_32(x) \
	((u_int32_t)( \
		(((u_int32_t)(x) & (u_int32_t)0x000000ffUL) << 24) | \
		(((u_int32_t)(x) & (u_int32_t)0x0000ff00UL) <<  8) | \
		(((u_int32_t)(x) & (u_int32_t)0x00ff0000UL) >>  8) | \
		(((u_int32_t)(x) & (u_int32_t)0xff000000UL) >> 24) ))
	
#elif __BYTE_ORDER == __BIG_ENDIAN

/* big endian systems don't need this shit */
#define __swap_16(x) (x)
#define __swap_32(x) (x)

#else
#error "couldn't determine endianness"
#endif

/* Use to initialise constants */
#define __constant_htons(x) __swap_16(x)
#define __constant_ntohs(x) __swap_16(x)
#define __constant_htonl(x) __swap_32(x)
#define __constant_ntohl(x) __swap_32(x)

#endif /* __PMACROS_HEADER_INCLUDED__ */
