#ifndef __TEMPLATE_HEADER_INCLUDED__
#define __TEMPLATE_HEADER_INCLUDED__

struct ptrptr{
	void *ptr;
};

struct longrange {
	u_int32_t	min;
	u_int32_t	max;
};

struct shortrange {
	u_int16_t	min;
	u_int16_t	max;
};

/* Error detecting string->unsigned int conversion */
static inline int strtouint(const char *s, unsigned int *v)
{
	unsigned int d;
	int p;

	for(*v=0,p=0; (d=(unsigned int)(s[p] - '0')) < 10; p++) {
		*v=*v*10+d;
	}

	return p;
}

#ifndef __PLUGIN__
int template_longrange(char *, void **);
int template_shortrange(char *, void **);

void template_ptr(void *);
void template_ptrptr(struct ptrptr *);
#else
typedef int(*proc_template)(char *, void **);
#endif

#endif /* __TEMPLATE_HEADER_INCLUDED__ */
